<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:fam="http://www.media.hut.fi/as0110/2004/u2e1/family/"
xmlns:per="http://www.media.hut.fi/as0110/2004/u2e1/person/">
	<xsl:output encoding="ISO-8859-1" method="text"/>
	<xsl:template match="/">
		<!-- Count the total number of persons -->
		<xsl:text>Number of persons: </xsl:text>
		<xsl:value-of select="count(/*/*)"/>
		<!-- Count the amount of persons that have at least two brother elements inside the family element-->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>At least two brothers: </xsl:text>
		<xsl:value-of select="count(//*[count(fam:brother)&gt;=2])"/>
		<!-- Count the amount of persons that have exactly one brother element inside the family element-->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Exactly one brother: </xsl:text>
		<xsl:value-of select="count(//*[count(fam:brother)=1])"/>
		<!-- Count the total number of spouse elements-->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Spouses: </xsl:text>
		<xsl:value-of select="count(//per:spouse)"/>
		<!-- Count the total number of sister elements-->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Amount of 'sister' elements: </xsl:text>
		<xsl:value-of select="count(//fam:sister)"/>
		<!-- Count the amount of people with the last name "Smith"-->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Amount of people whose last name is Smith: </xsl:text>
		<xsl:value-of select="count(//*[per:lastname='Smith'])"/>
		<!-- Count the total number of persons who have an 'r' in 
their first name (case-insensitive) -->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>The letter 'r' included in the first name (case-insensitive): </xsl:text>
		<xsl:value-of select="count(//*[contains(per:firstname,'r') or contains(per:firstname,'R')])"/>
		<!-- Count the total number of persons who have an 'i' in their last name 
(case-insensitive) -->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>The letter 'i' included in the last name (case-insensitive): </xsl:text>
		<xsl:value-of select="count(//*[contains(per:lastname,'i') or contains(per:lastname,'I')])"/>
		<!-- The number of persons born before 1980 -->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Born before 1980: </xsl:text>
		<xsl:value-of select="count(//*[substring(per:dateOfBirth,1,4)&lt;'1980'])"/>
		<!-- The number of persons born before 1950 -->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>Born before 1950: </xsl:text>
		<xsl:value-of select="count(//*[substring(per:dateOfBirth,1,4)&lt;'1950'])"/>
		<!-- Count the number of persons that do not have a child element. -->
		<xsl:text>&#xA;</xsl:text>
		<xsl:text>No child elements: </xsl:text>
		<xsl:value-of select="count(//per:person[count(fam:family/fam:child)=0])"/>
		<!-- Finally, print the persons in the order they appear in the document. Before the name, there is a number indicating the 
position of the person -->
		<xsl:for-each select="/*/*">
			<xsl:text>&#xA;</xsl:text>
			<!-- The position -->
			<xsl:value-of select="position()"/>
			<xsl:text>. </xsl:text>
			<!-- Last name -->
			<xsl:value-of select="per:name/per:lastname"/>
			<xsl:text>, </xsl:text>
			<!-- First name -->
			<xsl:value-of select="per:name/per:firstname"/>
		</xsl:for-each>
		<xsl:text>&#xA;***</xsl:text>
	</xsl:template>
</xsl:stylesheet>
