<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="text" encoding="ISO-8859-1"/>
	<xsl:template match="/">
		
		<!-- Total number of all coaches -->
		
		<xsl:text>Number of coaches: </xsl:text>
		<xsl:value-of select="count(/*/coaches/*)"/>
		<xsl:text>&#x0a;</xsl:text> <!-- line feed -->
		
		
		<!-- The average age of caretakers rounded to the nearest integer -->
		
		<xsl:text>Average age of caretakers: </xsl:text>
		<xsl:value-of select="round(sum(//*/caretaker/@age) div count(//*/caretaker))"/>
		<xsl:text>&#x0a;</xsl:text>
		
		
		<!-- The age of the player named Janne Immonen-->
		
		<xsl:text>Age of Janne Immonen: </xsl:text>
		<xsl:value-of select="/team/players/player[name[firstname = 'Janne' and lastname = 'Immonen' ]]/@age"/>
		<xsl:text>&#x0a;</xsl:text>
		
		
		<!-- The average age of defenders rounded to the nearest integer -->
	
		<xsl:text>Average age of defenders: </xsl:text>
		<xsl:value-of select="round(sum(/team/players/player[@position='defender']/@age) div count(/team/players/player[@position='defender']))"/>
		<xsl:text>&#x0a;</xsl:text>
		
		
		<!-- Print the lastname of the caretaker who is the first caretaker before the caretaker called Matti Nenonen and the firstname of the fifth forward separated with a single space. (ie. Immonen Kimmo) -->
			<xsl:text>Mixed name: </xsl:text>
			<xsl:value-of select="concat(//caretaker[name/firstname='Matti' and name/lastname='Nenonen']/preceding-sibling::*[position()=last()-1]/*/lastname, ' ', /team/players/player[@position='forward'][position()=5]/name/firstname)"/>
		<xsl:text>&#x0a;</xsl:text>
		
	</xsl:template>
</xsl:stylesheet>