<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="text" encoding="iso-8859-1"/>
	<xsl:template match="/">
		<!-- Prints firstname of each defender on its own line  -->
		
		<xsl:for-each select="/*/*/player[@position='defender']">
			<xsl:text>Defender: </xsl:text>
			<xsl:value-of select="name/firstname"></xsl:value-of>
			<xsl:text>&#x0a;</xsl:text> <!-- line feed -->
		</xsl:for-each>
		<xsl:text>***&#x0a;</xsl:text> <!-- separator and line feed -->
		<!-- Selects the second sibling after each person  with firstname Tero and prints their surnames each on its own line. Prints an empty line if there is no second sibling after Tero -->		
		<xsl:for-each select="/*/*/*[name[firstname='Tero']]">
			<xsl:text>Second person after Tero: </xsl:text>
			<xsl:value-of select="following-sibling::*[position()=2]/name/lastname"></xsl:value-of>
			<xsl:text>&#x0a;</xsl:text>
		</xsl:for-each>
		<xsl:text>***&#x0a;</xsl:text>
	
		<!-- Prints a nickname for each coach one per line. A nickname is of the form "firstnameXX" where XX are the two last digits of the persons year of birth. You may suppose that every coach has already celebrated his/her birthday this year. -->
		
		<xsl:for-each select="/team/coaches/*">
			<xsl:text>Nickname: </xsl:text>
			<xsl:value-of select="concat(name/firstname, substring(string(2004-@age), 3, 2))"></xsl:value-of>
			<xsl:text>&#x0a;</xsl:text>
		</xsl:for-each>
		<xsl:text>***&#x0a;</xsl:text>
		<!-- Prints all information of each coach, one coach per line, in the following form: "firstname lastname: attribute1name attribute1value attribute2name attribute2value...". If there are underline characters ("_")  in the attribute names, replace them with normal spaces (" "). Make sure that there are no extra spaces (or any other characters) in the end of lines.  -->
		
		<xsl:for-each select="/team/coaches/*"> <!-- Choose coaches here -->
			<xsl:text>Coach: </xsl:text>	
			<xsl:value-of select="concat(name/firstname, ' ', name/lastname, ': ')"></xsl:value-of>
			<xsl:for-each select="@*">  <!-- Choose attributes here -->
				<xsl:value-of select="concat(translate(name(.), '_', ' '), ' ', string(.), ' ')"></xsl:value-of>
			</xsl:for-each>			
			<xsl:text>&#x0a;</xsl:text>
		</xsl:for-each>
		<xsl:text>***</xsl:text>		
	</xsl:template>
</xsl:stylesheet>
