<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output doctype-system="http://www.w3.org/TR/html4/loose.dtd" 
		doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
		encoding="iso-8859-1"
		method="html"/>
	<xsl:template match="/">
		
		<html>
			<head>
				<title><xsl:value-of select="//title"/></title>
			</head>
			<body>
				<p>
					<b>From: </b>
					<a>	<xsl:attribute name="href">mailto:<xsl:value-of select="//sender/@email"/></xsl:attribute>
					<xsl:value-of select="//sender/firstname"/><xsl:text> </xsl:text><xsl:value-of select="//sender/lastname"/></a>
					<br/>
					<b>To: </b>
					<a><xsl:attribute name="href">mailto:<xsl:value-of select="//receiver/@email"/></xsl:attribute>
					<xsl:value-of select="//receiver/firstname"/><xsl:text> </xsl:text><xsl:value-of select="//receiver/lastname"/></a>
				</p>
				<h1><xsl:value-of select="//title"/></h1>
				<p>
					<xsl:apply-templates select="//textBody"/>
				</p>
				<p>
					<i><xsl:value-of select="//sender/firstname"/></i>
				</p>
			</body>
		</html>
	</xsl:template>
	<xsl:template match="//textBody/strong">
		<b><xsl:value-of select="."/></b>
	</xsl:template>
	<xsl:template match="//textBody/emphasized">
		<i><xsl:value-of select="."/></i>
	</xsl:template>
</xsl:stylesheet>
