<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output omit-xml-declaration="yes"/>
	<xsl:template match="/">
		<xsl:for-each select="/familyTree/person">
			<xsl:sort select="name/lastname"/>
			<xsl:sort select="name/firstname"/>
			<xsl:value-of select="position()"/>
			<xsl:text>. </xsl:text>
			<xsl:value-of select="name/lastname"/>
			<xsl:text>, </xsl:text>
			<xsl:value-of select="name/firstname"/>
			<xsl:text>&#10;</xsl:text>
		</xsl:for-each>
		<xsl:text>***&#10;</xsl:text>
		<xsl:for-each select="/familyTree/person">
			<xsl:sort select="dateOfBirth" order="descending"/>
			<xsl:value-of select="position()"/>
			<xsl:text>. </xsl:text>
			<xsl:value-of select="name/lastname"/>
			<xsl:text>, </xsl:text>
			<xsl:value-of select="name/firstname"/>
			<xsl:text>: </xsl:text>
			<xsl:value-of select="dateOfBirth"/>
			<xsl:text>&#10;</xsl:text>
		</xsl:for-each>
		<xsl:text>***&#10;</xsl:text>
		<xsl:for-each select="/familyTree/person[contains(@id,'b')]">
			<xsl:sort select="name/firstname"/>
			<xsl:value-of select="name/firstname"/>
			<xsl:if test="position() != last()">
				<xsl:text>, </xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:text>&#10;***&#10;</xsl:text>
		<xsl:for-each select="/familyTree/person[family/child]">
			<xsl:value-of select="name/firstname"/>
			<xsl:text> </xsl:text>
			<xsl:value-of select="name/lastname"/>
			<xsl:text>: </xsl:text>
			<xsl:for-each select="family/child">
				<xsl:variable name="ide" select="self::node()/@idref"/>
				<xsl:value-of select="/familyTree/person[@id = $ide]/name/firstname"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="/familyTree/person[@id = $ide]/name/lastname"/>
				<xsl:if test="position() != last()">
					<xsl:text>, </xsl:text>
				</xsl:if>
			</xsl:for-each>
			<xsl:text>&#10;</xsl:text>
		</xsl:for-each>
		<xsl:text>***&#10;</xsl:text>
	</xsl:template>
</xsl:stylesheet>
