<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output omit-xml-declaration="yes"/>
	<xsl:template match="/">
		<xsl:variable name="vika" select="ceiling(n)"/>
		<xsl:choose>
			<xsl:when test="$vika &gt; 0">
				<xsl:variable name="fibo">
					<xsl:call-template name="lasku">
						<xsl:with-param name="luku1" select="0"/>
						<xsl:with-param name="luku2" select="1"/>
						<xsl:with-param name="luku" select="$vika"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:value-of select="$fibo"/>
			</xsl:when>
			<xsl:when test="$vika = 0">
				<xsl:text>0</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>Invalid input</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#x0a;</xsl:text>
	</xsl:template>
	<xsl:template name="lasku">
		<xsl:param name="luku1"/>
		<xsl:param name="luku2"/>
		<xsl:param name="summa" select="$luku1 + $luku2"/>
		<xsl:param name="luku"/>
		<xsl:choose>
			<xsl:when test="$luku &gt; 0">
				<xsl:value-of select="$luku1"/>
				<xsl:text>,</xsl:text>
				<xsl:call-template name="lasku">
					<xsl:with-param name="luku1" select="$luku2"/>
					<xsl:with-param name="luku2" select="$summa"/>
					<xsl:with-param name="luku" select="$luku - 1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
			<xsl:value-of select="$luku1"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
