import tools.*;

import org.w3c.dom.*;
import javax.xml.parsers.*;

public class U4e1 {

    private MyParser parseri;
    private Document dokumentti;

    public U4e1(String tiedosto) {
	this.parseri = new MyParser();
	this.dokumentti = this.parseri.parse(tiedosto);
    }

    private void kaynnista() {
        Node kayttis = this.dokumentti.getDocumentElement().getFirstChild();
        Node passu = this.dokumentti.getDocumentElement().getLastChild();
        Authentication varmistus = new Authentication(kayttis.getFirstChild().getNodeValue(), passu.getFirstChild().getNodeValue());
	DummyDatabase tietokanta = new DummyDatabase();
	Person henkilo = tietokanta.search(varmistus);
	DocumentBuilderFactory tehdas = DocumentBuilderFactory.newInstance();
	DocumentBuilder rakentaja;
	try {
	    rakentaja = tehdas.newDocumentBuilder();
	} catch (ParserConfigurationException pce) {
	    pce.printStackTrace();
	    return;
	}
	if (henkilo != null) {
	    Document dokkari = rakentaja.newDocument();
	    Element persoona = dokkari.createElement("person");
	    dokkari.appendChild(persoona);
	    Attr ika = dokkari.createAttribute("age");
	    ika.setValue(Integer.toString(henkilo.getAge()));
	    persoona.setAttributeNode(ika);
	    Element nimi = dokkari.createElement("name");
	    persoona.appendChild(nimi);
	    Element etunimi = dokkari.createElement("firstname");
	    etunimi.appendChild(dokkari.createTextNode(henkilo.getFirstname()));
	    nimi.appendChild(etunimi);
	    Element sukunimi = dokkari.createElement("lastname");
	    sukunimi.appendChild(dokkari.createTextNode(henkilo.getLastname()));
	    nimi.appendChild(sukunimi);
	    Element authi = dokkari.createElement("authentication");
	    persoona.appendChild(authi);
	    Element tunnus = dokkari.createElement("username");
	    tunnus.appendChild(dokkari.createTextNode(henkilo.getUsername()));
	    authi.appendChild(tunnus);
	    Element salasana = dokkari.createElement("password");
	    salasana.appendChild(dokkari.createTextNode(henkilo.getPassword()));
	    authi.appendChild(salasana);
	    Element osote = dokkari.createElement("address");
	    persoona.appendChild(osote);
	    Element tie = dokkari.createElement("street");
	    tie.appendChild(dokkari.createTextNode(henkilo.getStreetAddress()));
	    osote.appendChild(tie);
	    Element posti = dokkari.createElement("postalCode");
	    posti.appendChild(dokkari.createTextNode(henkilo.getPostalCode()));
	    osote.appendChild(posti);
	    Element kaupunki = dokkari.createElement("city");
	    kaupunki.appendChild(dokkari.createTextNode(henkilo.getCity()));
	    osote.appendChild(kaupunki);

	    MyXMLPrinter tulostin = new MyXMLPrinter();
	    tulostin.print(dokkari);
	} else
	    System.out.println("Error: No person found. Check username and password.");
    }

    public static void main(String[] args) {
	if (args.length > 0) {
	    String tiedosto = args[0];
	    U4e1 ohjelma = new U4e1(tiedosto);
	    ohjelma.kaynnista();
	}
    }
}
