import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.util.*;

public class Parseri {

    private String eka, toka;

    public Parseri(String tiedosto1, String tiedosto2) {
	this.eka = tiedosto1;
	this.toka = tiedosto2;
    }

    private void parsi() {
	DocumentBuilderFactory tehdas = DocumentBuilderFactory.newInstance();
        tehdas.setNamespaceAware(true);
        tehdas.setValidating(true);
	DocumentBuilder rakentaja;
	try {
	    rakentaja = tehdas.newDocumentBuilder();
	} catch (ParserConfigurationException pce) {
	    pce.printStackTrace();
	    return;
	}
	TiedostonLukija lukija = new TiedostonLukija();
        Document doku1 = lukija.lue(this.eka);
        Document doku2 = lukija.lue(this.toka);
        SortedSet setti = new TreeSet();
        Node juuri1 = doku1.getDocumentElement();
        Node juuri2 = doku2.getDocumentElement();
        NodeList levyt1 = doku1.getDocumentElement().getChildNodes();
        NodeList levyt2 = doku2.getDocumentElement().getChildNodes();
        Node solmu;
        NodeList solmut;
        Node[] sisaret = new Node[4];
        int k = 0;

        //Ensin eka kokoelma
        for (int i = 0; i < levyt1.getLength(); i++) {
            if (!levyt1.item(i).getNodeName().equals("#text")) {
                solmut = levyt1.item(i).getChildNodes();
                k = 0;
                for (int j = 0; j < solmut.getLength(); j++) {
                    solmu = solmut.item(j);
                    if (!solmu.getNodeName().equals("#text")) {
			sisaret[k] = solmu;
			k++;
                    }
                    if (k == 4)
			setti.add(new Levy(sisaret[0].getFirstChild().getNodeValue(),
					   sisaret[1].getFirstChild().getNodeValue(),
					   Integer.parseInt(sisaret[3].getFirstChild().getNodeValue()),
					   Double.parseDouble(sisaret[2].getFirstChild().getNodeValue())));
                }
            }
        }

        //sitten toka
        for (int i = 0; i < levyt2.getLength(); i++) {
            if (!levyt2.item(i).getNodeName().equals("#text")) {
                sisaret[0] = levyt2.item(i).getAttributes().item(0);
                solmut = levyt2.item(i).getChildNodes();
                k = 1;
                for (int j = 0; j < solmut.getLength(); j++) {
                    solmu = solmut.item(j);
                    if (!solmu.getNodeName().equals("#text")) {
			sisaret[k] = solmu;
			k++;
                    }
                    if (k == 4) {
                        Levy alppari = new Levy(sisaret[2].getFirstChild().getNodeValue(),
					   sisaret[3].getFirstChild().getNodeValue(),
					   Integer.parseInt(sisaret[1].getFirstChild().getNodeValue()),
					   Double.parseDouble(sisaret[0].getNodeValue()));
			setti.add(alppari);
                    }
                }

            }
        }

        //Parsitaan samaan tiedostoon
        Document dokki = rakentaja.newDocument();
        Element tietokanta = dokki.createElement("database");
        dokki.appendChild(tietokanta);
        Iterator it = setti.iterator();
        while (it.hasNext()) {
            Levy joku = (Levy)it.next();
            Element albumi = dokki.createElement("album");
            Attr hinta = dokki.createAttribute("price");
            tietokanta.appendChild(albumi);
            hinta.setValue(Double.toString(joku.kerroHinta()));
            albumi.setAttributeNode(hinta);
            Attr maara = dokki.createAttribute("quantity");
            maara.setValue(Integer.toString(joku.kerroLukumaara()));
            albumi.setAttributeNode(maara);
            Element artisti = dokki.createElement("artist");
            artisti.appendChild(dokki.createTextNode(joku.kerroArtisti()));
            albumi.appendChild(artisti);
            Element levy = dokki.createElement("title");
            levy.appendChild(dokki.createTextNode(joku.kerroLevynNimi()));
            albumi.appendChild(levy);
        }

        MyXMLPrinter ulostin = new MyXMLPrinter();
        ulostin.print(dokki);

    }

    public static void main(String[] args) {
	Parseri parseri = new Parseri(args[0], args[1]);
	parseri.parsi();
    }

}
